use crate::middlewares::error::ErrorResponse;
use crate::services::spotify;
use actix_web::{get, web, HttpResponse, Result, Scope};
use serde::{Deserialize, Serialize};

pub fn routes() -> Scope {
    web::scope("/search").service(search)
}

#[derive(Deserialize)]
struct SearchQuery {
    q: String,
}

#[derive(Serialize)]
struct SearchResponse {
    track: (),
}

#[get("")]
async fn search(query: web::Query<SearchQuery>) -> Result<HttpResponse, ErrorResponse> {
    let spotify = spotify::instance().await;
    let track = spotify.search(&query.q).await;

    Ok(HttpResponse::Ok().json(SearchResponse { track }))
}
